/* 

                        XPacspr.c

                     (Sylvain Huet x91)
                 (huet@poly.polytechnique.fr)

*/

#include "xpac1.h"

/*	definition de la structure fenetre utilisee pour le rafraichissement */
void clearfenclc(fen f)
	{
	f->g=0x8000;
	}

void ajfenclc(fen g,fen f)
	{
	if (f->g!=0x8000)
		{
		if (g->g<f->g) f->g=g->g;
		if (g->d>f->d) f->d=g->d;
		if (g->h<f->h) f->h=g->h;
		if (g->b>f->b) f->b=g->b;
		}
	else	{
		f->g=g->g; f->h=g->h;
		f->d=g->d; f->b=g->b;
		}
	}

struct Fen fn[nbfen];

void inifn()
	{
		int	i;

	for (i=0;i<nbfen;i++) clearfenclc(&fn[i]);
	}

void affzone(fen f)
	{
		struct Fen	g,*p;
		int	i,j=0;
		long	k=0x7fffffff,m,n;

	n=(long)(f->d-f->g)*(long)(f->b-f->h);
	for (i=0;i<nbfen;i++)
		{
		p=&fn[i];
		if(p->g==0x8000) m=n;
		else	{
			g=*p;
			ajfenclc(f,&g);
			m=(long)(g.d-g.g)*(long)(g.b-g.h)
				-(long)(p->d-p->g)*(long)(p->b-p->h);
			}
		if (m<k)
			{
			k=m; j=i;
			}
		}
	ajfenclc(f,&fn[j]);
	}

void affscreen()
	{
		struct Fen	f;

	f.g=0; f.h=0; f.d=640; f.b=400;
	affzone(&f);
	}

void affenclc(fen f)
	{
	if (f->g!= 0x8000) affzone(f);
	f->g=0x8000;
	}

void affn()
	{
		int	i;

	for(i=0;i<nbfen;i++)
		if (fn[i].g!=0x8000)
			{
			XCopyArea(display,dessin,win,gc
				,fn[i].g,fn[i].h
				,fn[i].d-fn[i].g,fn[i].b-fn[i].h
				,fn[i].g,fn[i].h);
			clearfenclc(&fn[i]);
			}
	}


/* definition des routines de gestion de sprite	*/

void inisprite()
	{
		int	i;
	for(i=0;i<nbsprite;i++)
		fs[i].type=0x8000;
	}

/* cree un nouveau sprite qui sera affiche immediatement,
retourne le numero du sprite : -1 si complet	*/

int createsprite(Pixmap pixform, Pixmap pixfond, int x, int y
			, int width, int height, int pref)
	{
		int	i=pref;
	if ((pref==-1)||(pref>=nbsprite))
		{
		i=0;
		while((i<nbsprite)&&(fs[i].type!=0x8000)) i++;
		if (i==nbsprite) return -1;
		}
	fs[i].type=0;
	fs[i].pixform=pixform;
	fs[i].pixfond=pixfond;
	fs[i].x=x; fs[i].y=y;
	fs[i].width=width; fs[i].height=height;
	return i;
	}

void deletesprite(int i)
	{
	fs[i].type=0x8000;
	}

void clssprite()
	{
		int	i;
		struct Fen f;

	for(i=0;i<nbsprite;i++)
		if (fs[i].type!=0x8000)
			{
			XCopyArea(display,fond,dessin,gc
				,f.g=fs[i].x,f.h=fs[i].y
				,f.d=fs[i].width,f.b=fs[i].height
				,fs[i].x,fs[i].y);
			f.d+=f.g; f.b+=f.h;
			affzone(&f);
			}
	}

void affsprite()
	{
		int	i;
		struct Fen f;

	for(i=0;i<nbsprite;i++)
		if (fs[i].type!=0x8000)
			{
			XCopyArea(display,fs[i].pixfond,dessin,gcfond
				,0,0,f.d=fs[i].width,f.b=fs[i].height
				,f.g=fs[i].x,f.h=fs[i].y);
			XCopyArea(display,fs[i].pixform,dessin,gcform
				,0,0,f.d,f.b,f.g,f.h);
			f.d+=f.g; f.b+=f.h;
			affzone(&f);
			}
	}






